<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/thread/mle_router.cpp File Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d9/d88/mle__router_8cpp.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#namespaces">Namespaces</a> &#124;
<a href="#define-members">Macros</a>  </div>
  <div class="headertitle">
<div class="title">mle_router.cpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This file implements MLE functionality required for the Thread Router and Leader roles.  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &lt;<a class="el" href="../../da/d7b/code__utils_8hpp_source.html">common/code_utils.hpp</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="../../da/d7b/debug_8hpp_source.html">common/debug.hpp</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="../../d0/da9/logging_8hpp_source.html">common/logging.hpp</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="../../df/d57/encoding_8hpp_source.html">common/encoding.hpp</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="../../d1/d97/mac__frame_8hpp_source.html">mac/mac_frame.hpp</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="../../d0/dba/icmp6_8hpp_source.html">net/icmp6.hpp</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="../../d1/d79/random_8h_source.html">platform/random.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="../../d6/d6f/mle__router_8hpp_source.html">thread/mle_router.hpp</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="../../d1/d54/thread__netif_8hpp_source.html">thread/thread_netif.hpp</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="../../d8/d26/thread__tlvs_8hpp_source.html">thread/thread_tlvs.hpp</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="../../d5/d00/thread__uris_8hpp_source.html">thread/thread_uris.hpp</a>&gt;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for mle_router.cpp:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/de6/mle__router_8cpp__incl.png" border="0" usemap="#src_2core_2thread_2mle__router_8cpp" alt=""/></div>
<map name="src_2core_2thread_2mle__router_8cpp" id="src_2core_2thread_2mle__router_8cpp">
<area shape="rect" id="node2" href="../../da/d7b/code__utils_8hpp.html" title="This file includes macros for validating runtime conditions. " alt="" coords="5,865,167,891"/>
<area shape="rect" id="node4" href="../../da/d7b/debug_8hpp.html" title="This file includes functions for debugging. " alt="" coords="3703,792,3843,817"/>
<area shape="rect" id="node8" href="../../d0/da9/logging_8hpp.html" title="This file includes functions for debugging. " alt="" coords="3534,792,3679,817"/>
<area shape="rect" id="node13" href="../../df/d57/encoding_8hpp.html" title="This file includes definitions for byte&#45;ordering encoding. " alt="" coords="3115,945,3271,971"/>
<area shape="rect" id="node15" href="../../d1/d97/mac__frame_8hpp.html" title="This file includes definitions for generating and processing IEEE 802.15.4 MAC frames. " alt="" coords="2734,865,2877,891"/>
<area shape="rect" id="node19" href="../../d0/dba/icmp6_8hpp.html" title="This file includes definitions for ICMPv6. " alt="" coords="2925,499,3030,524"/>
<area shape="rect" id="node25" href="../../d1/d79/random_8h.html" title="This file includes the platform abstraction for true random number generation. " alt="" coords="2880,945,3010,971"/>
<area shape="rect" id="node26" href="../../d6/d6f/mle__router_8hpp.html" title="This file includes definitions for MLE functionality required by the Thread Router and Leader roles..." alt="" coords="2760,172,2912,197"/>
<area shape="rect" id="node38" href="../../d8/d26/thread__tlvs_8hpp.html" title="This file includes definitions and methods for generating and processing Thread Network Layer TLVs..." alt="" coords="2645,259,2799,284"/>
<area shape="rect" id="node39" href="../../d1/d54/thread__netif_8hpp.html" title="This file includes definitions for the Thread network interface. " alt="" coords="1796,92,1955,117"/>
<area shape="rect" id="node50" href="../../d5/d00/thread__uris_8hpp.html" title="This file includes definitions for Thread URIs. " alt="" coords="3661,92,3816,117"/>
<area shape="rect" id="node3" href="../../d9/d5e/stdbool_8h_source.html" title="stdbool.h" alt="" coords="666,1099,741,1124"/>
<area shape="rect" id="node9" href="../../df/dcb/openthread-core-config_8h.html" title="This file includes compile&#45;time configuration constants for OpenThread. " alt="" coords="1453,865,1624,891"/>
<area shape="rect" id="node11" href="../../d5/d77/logging_8h.html" title="This file includes the platform abstraction for the debug log service. " alt="" coords="3356,1025,3483,1051"/>
<area shape="rect" id="node10" href="../../d7/d08/openthread-core-default-config_8h.html" title="This file includes default compile&#45;time configuration constants for OpenThread. " alt="" coords="1457,939,1620,977"/>
<area shape="rect" id="node12" href="../../df/dd8/stdint_8h_source.html" title="stdint.h" alt="" coords="2328,1099,2392,1124"/>
<area shape="rect" id="node16" href="../../dc/dbf/openthread-types_8h.html" title="This file defines the types and structures used in the OpenThread library API. " alt="" coords="1348,1025,1484,1051"/>
<area shape="rect" id="node18" href="../../d7/d62/radio_8h.html" title="This file defines the radio interface for OpenThread. " alt="" coords="2245,945,2359,971"/>
<area shape="rect" id="node17" href="../../d3/da9/toolchain_8h_source.html" title="platform/toolchain.h" alt="" coords="1347,1099,1485,1124"/>
<area shape="rect" id="node20" href="../../db/d51/ip6__headers_8hpp.html" title="This file includes definitions for IPv6 packet processing. " alt="" coords="2315,645,2458,671"/>
<area shape="rect" id="node21" href="../../d5/d8c/message_8hpp.html" title="This file includes definitions for the message buffer pool and message buffers. " alt="" coords="2250,792,2406,817"/>
<area shape="rect" id="node23" href="../../dc/d02/ip6__address_8hpp.html" title="This file includes definitions for IPv6 addresses. " alt="" coords="2010,792,2152,817"/>
<area shape="rect" id="node24" href="../../d0/d86/netif_8hpp.html" title="This file includes definitions for IPv6 network interfaces. " alt="" coords="2366,719,2460,744"/>
<area shape="rect" id="node22" href="../../da/d45/openthread-config_8h_source.html" title="openthread&#45;config.h" alt="" coords="2484,865,2624,891"/>
<area shape="rect" id="node27" href="../../d1/d8d/coap__header_8hpp.html" title="This file includes definitions for generating and processing CoAP headers. " alt="" coords="2888,645,3045,671"/>
<area shape="rect" id="node28" href="../../dd/d28/coap__server_8hpp.html" title="This file includes definitions for the CoAP server. " alt="" coords="1837,499,1989,524"/>
<area shape="rect" id="node29" href="../../d0/db7/udp6_8hpp.html" title="This file includes definitions for UDP/IPv6 sockets. " alt="" coords="2146,572,2245,597"/>
<area shape="rect" id="node30" href="../../df/d05/timer_8hpp.html" title="This file includes definitions for the multiplexed timer service. " alt="" coords="1076,645,1207,671"/>
<area shape="rect" id="node31" href="../../d0/d11/trickle__timer_8hpp.html" title="This file includes definitions for the trickle timer logic. " alt="" coords="1174,339,1348,364"/>
<area shape="rect" id="node32" href="../../d0/d78/mle_8hpp.html" title="This file includes definitions for MLE functionality required by the Thread Child, Router, and Leader roles. " alt="" coords="2250,339,2360,364"/>
<area shape="rect" id="node35" href="../../df/d4b/topology_8hpp.html" title="This file includes definitions for maintaining Thread network topologies. " alt="" coords="2371,572,2509,597"/>
<area shape="rect" id="node36" href="../../d1/df7/mle__tlvs_8hpp.html" title="This file includes definitions for generating and processing MLE TLVs. " alt="" coords="2536,719,2674,744"/>
<area shape="rect" id="node33" href="../../da/db5/mac_8hpp.html" title="This file includes definitions for the IEEE 802.15.4 MAC. " alt="" coords="1560,499,1661,524"/>
<area shape="rect" id="node37" href="../../da/d7f/joiner__router_8hpp.html" title="This file includes definitions for the Joiner Router role. " alt="" coords="2317,419,2496,444"/>
<area shape="rect" id="node34" href="../../de/d0b/key__manager_8hpp.html" title="This file includes definitions for Thread security material generation. " alt="" coords="1406,572,1575,597"/>
<area shape="rect" id="node40" href="../../d9/d7e/leader_8hpp.html" title="This file includes definitions for a MeshCoP Leader. " alt="" coords="1984,259,2125,284"/>
<area shape="rect" id="node41" href="../../da/d32/ip6__filter_8hpp.html" title="This file includes definitions for IPv6 datagram filtering. " alt="" coords="2301,172,2421,197"/>
<area shape="rect" id="node42" href="../../d9/d2d/address__resolver_8hpp.html" title="This file includes definitions for Thread EID&#45;to&#45;RLOC mapping and caching. " alt="" coords="1315,419,1506,444"/>
<area shape="rect" id="node43" href="../../d8/d26/announce__begin__server_8hpp.html" title="This file includes definitions for responding to Announce Requests. " alt="" coords="367,412,528,451"/>
<area shape="rect" id="node44" href="../../df/d7a/energy__scan__server_8hpp.html" title="This file includes definitions for responding to Energy Scan Requests. " alt="" coords="814,412,953,451"/>
<area shape="rect" id="node45" href="../../dd/d07/network__diag_8hpp.html" title="This file includes definitions for handle network diagnostic. " alt="" coords="1681,419,1849,444"/>
<area shape="rect" id="node46" href="../../d2/d1d/meshcop__dataset__manager_8hpp.html" title="This file includes definitions for managing MeshCoP Datasets. " alt="" coords="1792,252,1960,291"/>
<area shape="rect" id="node47" href="../../da/d80/mesh__forwarder_8hpp.html" title="This file includes definitions for forwarding IPv6 datagrams across the Thread mesh. " alt="" coords="1372,339,1556,364"/>
<area shape="rect" id="node48" href="../../d0/d03/network__data__local_8hpp.html" title="This file includes definitions for manipulating local Thread Network Data. " alt="" coords="2444,165,2587,204"/>
<area shape="rect" id="node49" href="../../d9/d2d/panid__query__server_8hpp.html" title="This file includes definitions for responding to PANID Query Requests. " alt="" coords="654,412,791,451"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:d2/dd4/namespaceThread_1_1Mle"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/dd4/namespaceThread_1_1Mle.html">Thread::Mle</a></td></tr>
<tr class="memdesc:d2/dd4/namespaceThread_1_1Mle"><td class="mdescLeft">&#160;</td><td class="mdescRight">This namespace includes definitions for the MLE protocol. <br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a02ea32929cc78ee79cc2ad2b31360704"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a02ea32929cc78ee79cc2ad2b31360704"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>WPP_NAME</b>&#160;&#160;&#160;&quot;mle_router.tmh&quot;</td></tr>
<tr class="separator:a02ea32929cc78ee79cc2ad2b31360704"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This file implements MLE functionality required for the Thread Router and Leader roles. </p>
</div></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_fd71accbf528c1576ca21e7ec5716833.html">thread</a></li><li class="navelem"><a class="el" href="../../d9/d88/mle__router_8cpp.html">mle_router.cpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:35 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
